﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Public SQL1 As SQL
	Private NameTB As B4XView
	Private CityTB As B4XView
	Private AddressTB As B4XView
	Private StateTB As B4XView
	Private ZipTB As B4XView
	Private CustomListView1 As CustomListView
	Dim CurrentRecord As Int
	Dim CurrentIndex As Int
	Private DataLayoutPane As B4XView
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	Wait For (InitializeSQL) Complete (Result As Boolean)
	If Result =True Then
		LoadData
	End If
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub InitializeSQL() As ResumableSub
	Dim BigFail As String
	Try
	#If B4J
		SQL1.InitializeSQLite(File.GetFileParent(File.GetFileParent(File.DirApp)), "persons.db", False)
	#Else
		SQL1.Initialize(xui.DefaultFolder, "persons.db", False)
	#End If
		Return True
	Catch
		'This FIRST to capture the right $"[plain]${LastException.Message}[/plain]"$, THEN Sleep to wait for program to open so we can display the message
		BigFail = $"[plain]There was an error opening the database persons.db in ${File.GetFileParent(File.GetFileParent(File.DirApp))}
${LastException.Message}[/plain]"$
		Sleep(100)
		Wait For (xui.MsgboxAsync(BigFail, "MainPage: InitializeSQL")) Msgbox_Result (Result As Int)
		Return False
	End Try
End Sub

Private Sub SaveBtn_Click
Try
	Dim P As B4XView = CustomListView1.GetPanel(CurrentIndex)
	Log(P.GetView(0).GetView(0).Text)
	'Return
	If CurrentRecord = -1 Then
		SQL1.ExecNonQuery2($"INSERT INTO PList (Name, Address, City, State, Zip) SELECT ?, ?, ?, ?, ?;"$, Array As Object(P.GetView(0).GetView(0).Text, P.GetView(0).GetView(1).Text, P.GetView(0).GetView(2).Text, P.GetView(0).GetView(3).Text, P.GetView(0).GetView(4).Text))
	Else If CurrentRecord <> -1000 Then
			xui.Msgbox2Async($"Update ${P.GetView(0).GetView(0).Text}?"$, "Update User", "Yes", "No", "", Null)
			Wait For MsgBox_Result (Result As Int)
			If Result <> xui.DialogResponse_Positive Then Return
		SQL1.ExecNonQuery2($"UPDATE PList SET Name = ?, Address = ?, City = ?, State = ?, Zip = ? WHERE ID = ?;"$, Array As Object(P.GetView(0).GetView(0).Text, P.GetView(0).GetView(1).Text, P.GetView(0).GetView(2).Text, P.GetView(0).GetView(3).Text, P.GetView(0).GetView(4).Text, CurrentRecord))
	End If
	LoadData
Catch
	Log(LastException)
End Try
End Sub

Private Sub DeleteBtn_Click
	Dim P As B4XView = CustomListView1.GetPanel(CurrentIndex)
	xui.Msgbox2Async($"Delete ${P.GetView(0).GetView(0).Text}?"$, "Update User", "Yes", "No", "", Null)
	Wait For MsgBox_Result (Result As Int)
	If Result <> xui.DialogResponse_Positive Then Return
	SQL1.ExecNonQuery2($"DELETE FROM PList WHERE ID = ?;"$, Array As Object(CurrentRecord))
	LoadData
End Sub

Sub LoadData
	Dim R As ResultSet = SQL1.ExecQuery($"SELECT PList.* FROM PList;"$)
	CustomListView1.Clear
	Dim B As B4XView = xui.CreatePanel("")
	B.LoadLayout("DataLayOut")
	B.Height = 40
	CustomListView1.Add(B, -1000)
	NameTB.Text = "Name"
	NameTB.Enabled = False
	NameTB.TextColor = xui.Color_Green
	AddressTB.Text = "Address"
	AddressTB.Enabled = False
	AddressTB.TextColor = xui.Color_Green
	CityTB.Text = "City"
	CityTB.Enabled = False
	CityTB.TextColor = xui.Color_Green
	StateTB.Text = "State"
	StateTB.Enabled = False
	StateTB.TextColor = xui.Color_Green
	ZipTB.Text = "Zip"
	ZipTB.Enabled = False
	ZipTB.TextColor = xui.Color_Green

	Do While R.NextRow
		Dim B As B4XView = xui.CreatePanel("")
		B.LoadLayout("DataLayOut")
		B.Height = 40
		CustomListView1.Add(B, R.GetInt("ID"))
		NameTB.Text = R.GetString("Name")
		AddressTB.Text = R.GetString("Address")
		CityTB.Text = R.GetString("City")
		StateTB.Text = R.GetString("State")
		ZipTB.Text = R.GetString("Zip")
	Loop

End Sub

Private Sub NewBtn_Click
Dim B As B4XView = xui.CreatePanel("")
B.LoadLayout("DataLayOut")
B.Height = 40
CustomListView1.Add(B, -1)
CurrentRecord = -1
End Sub

Private Sub CustomListView1_ItemClick (Index As Int, Value As Object)
	CurrentRecord = Value
	CurrentIndex = Index
End Sub

Private Sub DataTBs_MouseClicked (EventData As MouseEvent)
CurrentIndex = CustomListView1.GetItemFromView(Sender)	
CurrentRecord = CustomListView1.GetValue(CurrentIndex)	
End Sub